#include "tlang.h"

#if defined(USE_SDL2)
    #include "SDL2/SDL.h"
    tobject_t* sdl2=NULL;
    tobject_t* __sdl_init_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
        
        if(args->length >= 1 && args->items[0]->type == tnumber)
        {
            return tobject_number(rt,SDL_Init((Uint32)args->items[0]->data.number));
        }
        return tobject_number(rt,SDL_Init(SDL_INIT_EVERYTHING));
    }  
    tobject_t* __sdl_renderclear_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
         if(args->length >= 1 && args->items[0]->type == tnumber)
        {
            int64_t n = (int64_t)args->items[0]->data.number;
            return tobject_number(rt,SDL_RenderClear((SDL_Renderer*)(void*)n));
        }
        return tobject_basic(rt,tnull);
    }

    tobject_t* __sdl_renderpresent_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
         if(args->length >= 1 && args->items[0]->type == tnumber)
        {
            int64_t n = (int64_t)args->items[0]->data.number;
            SDL_RenderPresent((SDL_Renderer*)(void*)n);
        }
        return tobject_basic(rt,tnull);
    }
    

    tobject_t* __sdl_destroywindow_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
        if(args->length >= 1 && args->items[0]->type == tnumber)
        {
            int64_t n = (int64_t)args->items[0]->data.number;
            SDL_DestroyWindow((SDL_Window*)(void*)n);
        }
        return tobject_basic(rt,tnull);
    }
    tobject_t* __sdl_setrendererdrawcolor_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
        if(args->length >= 5 && args->items[0]->type == tnumber && args->items[1]->type == tnumber && args->items[2]->type == tnumber && args->items[3]->type == tnumber && args->items[4]->type == tnumber)
        {
            int64_t n = (int64_t)args->items[0]->data.number;
            return tobject_number(rt,SDL_SetRenderDrawColor((SDL_Renderer*)(void*)n,(Uint8)args->items[1]->data.number,(Uint8)args->items[2]->data.number,(Uint8)args->items[3]->data.number,(Uint8)args->items[4]->data.number));
        }
        return tobject_basic(rt,tnull);
    }
     tobject_t* __sdl_createrenderer_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
        
        if(args->length >= 3 && args->items[0]->type == tnumber && args->items[1]->type == tnumber&& args->items[2]->type == tnumber)
        {
            int64_t n = (int64_t)args->items[0]->data.number;
            SDL_Renderer* r=SDL_CreateRenderer((SDL_Window*)(void*)n,(int)args->items[1]->data.number,(Uint32)args->items[2]->data.number);
           
            return tobject_number(rt,(double)(int64_t)r);           
        }
        return tobject_basic(rt,tnull);
    }
    tobject_t* __sdl_createwindow_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
    {
        if(args->length >= 6 && args->items[0]->type == tstring && args->items[1]->type == tnumber&& args->items[2]->type == tnumber&& args->items[3]->type == tnumber&& args->items[4]->type == tnumber&& args->items[5]->type == tnumber)
        {
            char* name = string_dupp(args->items[0]->data.string);
            SDL_Window* w=SDL_CreateWindow(name,(int)args->items[1]->data.number,(int)args->items[2]->data.number,(int)args->items[3]->data.number,(int)args->items[4]->data.number,(Uint32)args->items[5]->data.number);
            free(name);
            return tobject_number(rt,(double)(int64_t)w);           
        }
        return tobject_basic(rt,tnull);
    }
    void runtime_register_sdl2(runtime_t* rt)
    {
        if(sdl2 == NULL)
        {
            sdl2 = tobject_create(rt);
            sdl2->type = tdict;
            sdl2->data.dict = dict_create();
            runtime_create_method_on_dict(sdl2->data.dict,"destroyWindow",rt,NULL,__sdl_destroywindow_external_method,NULL);
            runtime_create_method_on_dict(sdl2->data.dict,"createRenderer",rt,NULL,__sdl_createrenderer_external_method,NULL);
            runtime_create_method_on_dict(sdl2->data.dict,"setRenderDrawColor",rt,NULL,__sdl_setrendererdrawcolor_external_method,NULL);
            runtime_create_method_on_dict(sdl2->data.dict,"renderClear",rt,NULL,__sdl_renderclear_external_method,NULL);
            runtime_create_method_on_dict(sdl2->data.dict,"renderPresent",rt,NULL,__sdl_renderpresent_external_method,NULL);
            
            runtime_create_method_on_dict(sdl2->data.dict,"createWindow",rt,NULL,__sdl_createwindow_external_method,NULL);
            runtime_create_method_on_dict(sdl2->data.dict,"init",rt,NULL,__sdl_init_external_method,NULL);
        }
        rt->globals->setvariable(rt->globals,"sdl",sdl2);
    }
#endif